/*

     ATP QWK MAIL READER FOR READING AND REPLYING TO QWK MAIL PACKETS.
     Copyright (C) 1992  Thomas McWilliams 
     Copyright (C) 1990  Rene Cougnenc
   
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 1, or (at your option)
     any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include "ansi.h"
#if defined(DJD) || defined(__TURBOC__)
#include "system.h"
#endif

extern int ansi ;            /* Will just return on ansi=0 */

#define ESC 27

#ifndef QDOS

#ifdef WIN32
#include <windows.h>
extern HANDLE hStdCon;
#endif

void cls()               /* Clear screen & home cursor */
{
#ifdef WIN32
	DWORD l;
	WORD  attr = 0;
	COORD coord;
	CONSOLE_SCREEN_BUFFER_INFO csb;
	short cl,ch;
	short i,j;
	fflush(stdout);
	coord.X = coord.Y = 0;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	SetConsoleCursorPosition(hStdCon, coord);	
	SetConsoleTextAttribute(hStdCon, 0);
	for(i = 0; i < csb.dwSize.Y; i++)
	{
		for(j =  0; j < csb.dwSize.X; j++) putchar(' ');
	}
	SetConsoleCursorPosition(hStdCon, coord);
	SetConsoleTextAttribute(hStdCon, 7);
	
	return;
#endif
    if( ansi )
	printf("%c[2J%c[H",ESC,ESC);
#ifdef DJD
    else
	{ gotoxy(1,1); clrscr();}
#endif
#ifdef __TURBOC__
    else
        clrscr() ;
#endif

}
void clear()             /* Reset Attributes          */
{
#ifdef WIN32
/*
	CONSOLE_SCREEN_BUFFER_INFO csb;
	fflush(stdout);
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.wAttributes &= 0xfff7;
	SetConsoleTextAttribute(hStdCon, csb.wAttributes);
*/
	return;
#endif
    if( ansi )
	printf("%c[0m",ESC );
}
void high()              /* HigLitht  (or BoldFace )  */
{
#ifdef WIN32
/*
	CONSOLE_SCREEN_BUFFER_INFO csb;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.wAttributes |= 8;
	SetConsoleTextAttribute(hStdCon, csb.wAttributes);
*/
	fflush(stdout);
	return;
#endif
	
    if( ansi )
	printf("%c[1m",ESC);
}
void blink()             /* blink mode                */
{
#ifdef WIN32
	fflush(stdout);
		return;
#endif
		
    if( ansi )
	printf("%c[5m",ESC);
}
#ifdef ATPUNUSED 
void deleol()            /* del to end of line        */
{
    if( ansi )
	printf("%c[K",ESC);
}
void reverse()           /* Revers video mode         */
{
    if( ansi )
	printf("%c[7m",ESC);
}

/*------------- Foreground colors ---------------------*/
void black()
{
    if( color && ansi )
	printf("%c[30m",ESC);
}
#endif
void red()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 4;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 8+4 /*csb.wAttributes*/);
	return;
#endif
    if( color && ansi )
	printf("%c[31m",ESC);
}
void green()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 2;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 10 /*csb.wAttributes*/);
	return;
#endif
    if( color && ansi )
	printf("%c[32m",ESC);
}
void yellow()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 6;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 14 /*csb.wAttributes*/);
	return;
#endif
	
    if( color && ansi )
	printf("%c[33m",ESC);
}
void blue()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 1;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 9 /*csb.wAttributes*/);
	return;
#endif
    if( color && ansi )
	printf("%c[34m",ESC);
}
void magenta()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 5;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 13 /*csb.wAttributes*/);
	return;
#endif

    if( color && ansi )
	printf("%c[35m",ESC);
}
void cyan()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= 0xfff8;
//	csb.wAttributes |= 3;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 11 /*csb.wAttributes*/);
	return;
#endif
    if( color && ansi )
	printf("%c[36m",ESC);
}
void white()
{
#ifdef WIN32
//	CONSOLE_SCREEN_BUFFER_INFO csb;
//	GetConsoleScreenBufferInfo(hStdCon, &csb);
//	csb.wAttributes &= ~0xfff8;
//	csb.wAttributes |= 7;
	fflush(stdout);
	SetConsoleTextAttribute(hStdCon, 15 /*csb.wAttributes*/);
	return;
#endif
    if( color && ansi )
	printf("%c[37m",ESC);
}

/*------------- BackGround colors ---------------------*/
void bblack()
{
#ifdef WIN32
	CONSOLE_SCREEN_BUFFER_INFO csb;
	fflush(stdout);
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.wAttributes &= 0xf;
	SetConsoleTextAttribute(hStdCon, csb.wAttributes);
	return;
#endif
    if( color && ansi )
	printf("%c[40m",ESC);
}
#ifdef ATPUNUSED 
void bred()
{
    if( color && ansi )
	printf("%c[41m",ESC);
}
void bgreen()
{
    if( color && ansi )
	printf("%c[42m",ESC);
}
void byellow()
{
    if( color && ansi )
	printf("%c[43m",ESC);
}
void bblue()
{
    if( color && ansi )
	printf("%c[44m",ESC);
}
void bmagenta()
{
    if( color && ansi )
	printf("%c[45m",ESC);
}
void bcyan()
{
    if( color && ansi )
	printf("%c[46m",ESC);
}
void bwhite()
{
    if( color && ansi )
	printf("%c[47m",ESC);
}

/*----------- Cursor position ---------------------------*/

void locate( x , y )
int x, y;
{
#ifdef WIN32
	COORD pos;
	pos.X = x;
	pos.Y = y;
	SetConsoleCursorPosition(hStdCon, pos);
	return;
#endif
    if(ansi)
	printf("%c[%d;%dH",ESC,y,x);
}

void up(nb)          /* Cursor Up default 1 */
int nb;
{
#ifdef WIN32
	CONSOLE_SCREEN_BUFFER_INFO csb;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.dwCursorPosition.Y -= (nb) ? nb : 1;
	SetConsoleCursorPosition(hStdCon, csb.dwCursorPosition);
	return;
#endif
    if ( ansi )
    {
        if( ! nb ) nb = 1 ; 
        printf("%c[%dA",ESC,nb);
    }
}

void dn(nb)        /* Cursor down default 1 */
int nb;
{
#ifdef WIN32
	CONSOLE_SCREEN_BUFFER_INFO csb;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.dwCursorPosition.Y += (nb) ? nb : 1;
	SetConsoleCursorPosition(hStdCon, csb.dwCursorPosition);
	return;
#endif
    if ( ansi )
    {
        if( ! nb ) nb = 1 ;
        printf("%c[%dB",ESC,nb);
    }
}

void right(nb)        /* Cursor right default 1 */
int nb;
{
#ifdef WIN32
	CONSOLE_SCREEN_BUFFER_INFO csb;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.dwCursorPosition.X += (nb) ? nb : 1;
	SetConsoleCursorPosition(hStdCon, csb.dwCursorPosition);
	return;
#endif

    if ( ansi )
    {
        if( ! nb ) nb = 1 ;
        printf("%c[%dC",ESC,nb);
    }
}

void left(nb)        /* Cursor left default 1 */
int nb;
{
#ifdef WIN32
	CONSOLE_SCREEN_BUFFER_INFO csb;
	GetConsoleScreenBufferInfo(hStdCon, &csb);
	csb.dwCursorPosition.X -= (nb) ? nb : 1;
	SetConsoleCursorPosition(hStdCon, csb.dwCursorPosition);
	return;
#endif
    if ( ansi )
    {
        if( ! nb ) nb = 1 ;
        printf("%c[%dD",ESC,nb);
    }
}
#endif
/*-----------------------------------------------------------------------*/

#else
#include <qdos.h>

#define CONSOLE fgetchid(stdout)

static fcol = GREEN_M4;
static bcol = BLACK_M4;

void cls()               /* Clear screen & home cursor */
{
    if( ansi )
    {
        sd_clear(CONSOLE, -1);
    }
}
void deleol()            /* del to end of line        */
{
    if( ansi )
    {
        sd_clrrt(CONSOLE, -1);
    }
}
void clear()             /* Reset Attributes          */
{
    if( ansi )
    {
        sd_setin(CONSOLE, -1, (fcol = GREEN_M4));
        sd_setst(CONSOLE, -1, (bcol = BLACK_M4));
        sd_setpa(CONSOLE, -1, BLACK_M4);
    }
}
void high()              /* HigLitht  (or BoldFace )  */
{
}
void blink()             /* blink mode                */
{
}
void reverse()           /* Revers video mode         */
{
    int x;
    if( ansi )
    {
        x = fcol;
        sd_setin(CONSOLE, -1, (fcol = bcol));
        sd_setst(CONSOLE, -1, (bcol = x));
        sd_setpa(CONSOLE, -1, x);
    }
}

/*------------- Foreground colors ---------------------*/
void black()
{
    if( ansi )
    {
        sd_setin(CONSOLE, -1, (fcol = BLACK_M4));
    }
}
void red()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = RED_M4));
}
void green()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = GREEN_M4));

}
void yellow()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = WHITE_M4));

}
void blue()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = GREEN_M4));

}
void magenta()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = RED_M4));

}
void cyan()
{
    if( ansi )
//      sd_setin(CONSOLE, -1, (fcol = GREEN_M4));
        sd_setin(CONSOLE, -1, (fcol = WHITE_M4));

}
void white()
{
    if( ansi )
        sd_setin(CONSOLE, -1, (fcol = WHITE_M4));
}

/*------------- BackGround colors ---------------------*/
void bblack()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, (bcol = BLACK_M4));
        sd_setpa(CONSOLE, -1, BLACK_M4);
    }
}

#ifdef ATPUNUSED 

void bred()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, (bcol = RED_M4));
        sd_setpa(CONSOLE, -1, RED_M4);
    }
}
void bgreen()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, (bcol = GREEN_M4));
        sd_setpa(CONSOLE, -1, GREEN_M4);
    }

}
void byellow()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, bcol = WHITE_M4);
        sd_setpa(CONSOLE, -1, WHITE_M4);
    }
}
void bblue()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, bcol = GREEN_M4);
        sd_setpa(CONSOLE, -1, GREEN_M4);
    }

}
void bmagenta()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, bcol = RED_M4);
        sd_setpa(CONSOLE, -1, RED_M4);
    }

}
void bcyan()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, bcol = GREEN_M4);
        sd_setpa(CONSOLE, -1, GREEN_M4);
    }

}
void bwhite()
{
    if( ansi )
    {
        sd_setst(CONSOLE, -1, bcol = WHITE_M4);
        sd_setpa(CONSOLE, -1, WHITE_M4);
    }

}

/*----------- Cursor position ---------------------------*/

void locate( x , y )
int x, y;
{
    if(ansi)
    {
        sd_pos(CONSOLE, -1, x-1, y-1);
    }
}

void up(nb)          /* Cursor Up default 1 */
int nb;
{
    if ( ansi )
    {
        int i;
        
        if( ! nb ) nb = 1 ;
        for(i = 0; i < nb; i++)
        {
            sd_prow(CONSOLE, -1);
        }
    }
}

void dn(nb)        /* Cursor down default 1 */
int nb;
{
    if ( ansi )
    {
        int i;
        
        if( ! nb ) nb = 1 ;
        for(i = 0; i < nb; i++)
        {
            sd_nrow(CONSOLE, -1);
        }
    }
}

void right(nb)        /* Cursor right default 1 */
int nb;
{
    if ( ansi )
    {
        int i;
        
        if( ! nb ) nb = 1 ;
        for(i = 0; i < nb; i++)
        {
            sd_ncol(CONSOLE, -1);
        }
    }
}

void left(nb)        /* Cursor left default 1 */
int nb;
{
    if ( ansi )
    {
        int i;
        
        if( ! nb ) nb = 1 ;
        for(i = 0; i < nb; i++)
        {
            sd_pcol(CONSOLE, -1);
        }
    }
}
#endif

#endif

